(function ($) {
  'use strict';
  $(function () {

      var editorSettings = wp.codeEditor.defaultSettings ? _.clone(wp.codeEditor.defaultSettings) : {};
      editorSettings.codemirror = _.extend(
        {},
        editorSettings.codemirror,
        {
          indentUnit: 2,
          tabSize: 2,
          mode: 'css',
        }
      );

      var editor = wp.codeEditor.initialize($('#code_editor_page_css'), editorSettings);


    function getStyle() {
      var style = {};
      style.folder = 'flags';
      style.file = $('#flag_style').val();
      var switcher_type = $('#switcher_type').val();
      if (switcher_type == 'dropdown') {
        style.folder = 'select';
        style.file = $('#select_style').val();
        if ($('#select_as_list').prop('checked')) {
          style.folder = 'list';
          style.file = $('#list_style').val();
        }
      }
      return style;
    }

    function update_code_editor(basic = 0) {
      var style = getStyle();
      var folder = style.folder;
      var style = style.file;
      var data = {
        action: 'load_style',
        whatever: ajax_object.we_value,
        style: style,
        folder: folder,
        basic: basic
      }
      $.post(ajaxurl, data, function (result) {
        editor.codemirror.toTextArea();
        $('#code_editor_page_css').val(result);
        editor = wp.codeEditor.initialize($('#code_editor_page_css'), editorSettings);
        toggleCodeEditor();
      });
    }

    function toggleCodeEditor() {
      var style = getStyle();
      var folder = style.folder;
      var style = style.file;
      if (folder == 'select' && style == 'default.css') {
        $('.CodeMirror-wrap').addClass('disabled');
      } else {
        $('.CodeMirror-wrap').removeClass('disabled');
      }
    }

    toggleCodeEditor();

    $(document).on('click', '.used-languages', function (e) {
      if ($(this).parent('div.lang-checkbox').hasClass('default_language')) {
        e.preventDefault();
        alert('You can\'t disable default language');
        return;
      }
      if ($(this).prop('checked') && !$(this).parent('div.lang-checkbox').hasClass('green')) {
        $(this).parent('div.lang-checkbox').addClass('green');
      } else {
        $(this).parent('div.lang-checkbox').removeClass('green');
      }
    });

    $(document).on('click', '#select_as_list', function () {
      if ($(this).prop('checked')) {
        $('#select-styles').addClass('hidden');
        $('#list-styles').removeClass('hidden');
      } else {
        $('#select-styles').removeClass('hidden');
        $('#list-styles').addClass('hidden');
      }
      update_code_editor();
    });

    $(document).on('change', '#switcher_type', function () {
      if ($(this).val() == 'flags') {
        $('#flag_styles').removeClass('hidden');
        if (!$('#dropdown_styles').hasClass('hidden')) {
          $('#dropdown_styles').addClass('hidden');
        }
      } else {
        if (!$('#flag_styles').hasClass('hidden')) {
          $('#flag_styles').addClass('hidden');
        }
        $('#dropdown_styles').removeClass('hidden');
      }
      update_code_editor();
    });

    $(document).on('change', '#flag_style', function () {
      update_code_editor();
    });

    $(document).on('change', '#list_style', function () {
      update_code_editor();
    });

    $(document).on('change', '#select_style', function () {
      update_code_editor();
    });

    $('#create_css_file').on('click', function (e) {
      e.preventDefault();
      $('#filename-wrapper').removeClass('hidden');
      $('#filename').val('custom');
      update_code_editor(1);
    });

    $('#cancel_create_css_file').on('click', function (e) {
      e.preventDefault();
      $('#filename').val('');
      $('#filename-wrapper').addClass('hidden');
      update_code_editor();
      $('#custom_css_editor').removeClass('disabled');
    });


  });//end jQuery

})(jQuery);
