<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://codingfix.com
 * @since      1.0.0
 *
 * @package    Cfx_Language_Switcher_For_Transposh
 * @subpackage Cfx_Language_Switcher_For_Transposh/admin/partials
 */
?>

<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<?php

$hidden = false;
if (!class_exists('transposh_plugin')) {
  echo '<div class="notice notice-error is-dismissible"><p>
    Language Switcher for Transposh plugin depends on Transposh plugin and can\'t do anything without it: please, install and activate Transposh plugin before to activate Edit Translation Button for Transposh.
  </p></div>';
  $hidden = true;
}
$transposh_options = get_option(TRANSPOSH_OPTIONS);
$used_languages = explode(',', $transposh_options['viewable_languages']);
$default_lang = $transposh_options['default_language'];
$usable_langs = explode(',', $transposh_options['viewable_languages']);
if (!isset($transposh_options) || !isset($default_lang) || empty($default_lang) || !isset($transposh_options['viewable_languages']) || empty($transposh_options['viewable_languages']) || count($usable_langs) <= 1) {
  echo '<div class="notice notice-error is-dismissible"><p class="plugin-invalid">
    <strong>Transposh languages not found.</strong> Maybe you still didn\'t set any languages in Transposh Languages settings. You must set at least 2 languages to use in your website in order to use Language Switcher for Transposh.
  </p></div>';
  $hidden = true;
}

$options = get_option('cfxlsft_options');
// $flag_path = LSFT_PLUGIN_URL . "/assets/flags";
$flag_path = plugins_url("/assets/flags", dirname(__FILE__, 2));
$en_flag = "gb";
if ($options['flag_type'] == 'tp') {
  $flag_path = TRANSPOSH_DIR_IMG . '/flags';
  $en_flag = "us";
}
// $default_styles = file_get_contents(LSFT_PLUGIN_URL . '/assets/styles/list/default.css');
$default_styles = file_get_contents(plugins_url('/assets/styles/list/default.css', dirname(__FILE__, 2)));
?>
<div id="cfxlsft-general" class="wrap">
  <h2>Language Switcher for Transposh Settings (LSFT)</h2>
  <?php
  if (
    isset($_GET['message'])
    && $_GET['message'] == '1'
  ) { ?>
    <div id='message' class='updated fade'>
      <p><strong>Settings
          Saved</strong></p>
    </div>
  <?php } ?>
  <?php
  // error_reporting(E_ALL);
  // // $locations = get_registered_nav_menus();
  // $locations = get_nav_menu_locations();
  // $menu = wp_get_nav_menu_object($locations['primary']);
  // $nav = wp_get_nav_menu_items($menu);
  // $nav = wp_nav_menu('primary');
  // echo '<pre>';
  // var_dump($nav);
  // echo '</pre>';
  ?>
  <br />
  <br />
  <form method="post" action="admin-post.php" class="<?php echo $hidden ? 'hidden' : '';  ?>">
    <input type="hidden" name="action" value="save_cfxlsft_options" />
    <!-- Adding security through hidden referrer field -->
    <?php wp_nonce_field('cfxlsft'); ?>
    <h3>Transposh settings</h3>
    <div class="postbox">
      <div class="settingsbox disabled">
        <h3>Default language in Transposh settings</h3>
        <div class="lang_wrapper">
          <div class="lang-div green">
            <span><?php echo ucfirst($default_lang) ?></span>
            <?php
            if (strtolower($default_lang) === 'en') {
            ?>
              <img src="<?php echo $flag_path ?>/<?php echo $en_flag  ?>.png" alt="English" />
            <?php
            } else {
            ?>
              <img src="<?php echo $flag_path ?>/<?php echo transposh_consts::get_language_flag($default_lang) ?>.png" alt="male" />
            <?php
            }
            ?>
            <span class="locale-code">(<?php echo transposh_consts::get_language_name($default_lang) ?>)</span>
          </div>
        </div>

        </p>
        <br />
        <hr>
        <br />
        <h3>Additional languages currently enabled in Transposh settings</h3>
        <div class="lang_wrapper">
          <?php
          foreach ($usable_langs as $lang) {
          ?>
            <div class="lang-div green">
              <span><?php echo ucfirst($lang) ?></span>
              <?php
              if ($lang === 'en') {
              ?>
                <img src="<?php echo $flag_path ?>/<?php echo $en_flag  ?>.png" />
              <?php
              } else {
              ?>
                <img src="<?php echo $flag_path ?>/<?php echo transposh_consts::get_language_flag($lang) ?>.png" />
              <?php
              }
              ?>
              <span class="locale-code">(<?php echo transposh_consts::get_language_name($lang) ?>)</span>
            </div>
          <?php
          }
          ?>
        </div>
      </div>
    </div>
    <br />
    <br />
    <h3>Menus</h3>
    <div class="postbox">
      <div class="settingsbox">
      <p>Set where the Language Switcher will show up:</p>
      <br>
      <div id="menu_locations_wrapper">
        <?php
        $menus = get_registered_nav_menus();
        $existing_menu_locations = explode(',', $options['menu_locations']);
        foreach ($menus as $key => $value){
          $checked = '';
          if (in_array($key, $existing_menu_locations)){
            $checked = 'checked';
          }
        ?>
        <div class="menu_location"><input type="checkbox" name="menu_locations[]" value="<?php echo $key ?>" <?php echo $checked ?> /><label><?php echo $value ?> <i>(<?php echo $key; ?>)</i></label></div>
        <?php
        }
        ?>
      </div>
      </div>
    </div>
    <br />
    <br />
    <h3>Flags</h3>
    <div class="postbox">
      <div class="settingsbox">
        <p>
          Choose between default Transposh flags and Language Switcher flags (for the moment some flag is missing and default Transposh will be used instead; I'm missing flags for the following languages: an, cs, cy, eh, england, es-ba, es-ca, es-ga, esperanto, europeanunion, gb-sc, gb-wa, hm, ru-ba, ru-ta, sj, us-ha)
        </p>
        <div class="flag-images">
          <?php
          $flag_type_options = array('lsft' => 'LSFT flags', 'tp' => 'Transposh flags');
          ?>
          <select name="flag_type" id="flag-switcher">
            <?php
            foreach ($flag_type_options as $value => $label) {
              $selected = '';
              if ($value == $options['flag_type']) {
                $selected = 'selected';
              }
            ?>
              <option value="<?php echo $value  ?>" <?php echo $selected ?>><?php echo $label ?></option>
            <?php
            }
            ?>
          </select>
        </div>
      </div>
    </div>

    <br />
    <br />
    <h3>Switcher type</h3>
    <div class="postbox">
      <div class="settingsbox">
        <p>Choose the type of Language Switcher you want to use:</p>
        <?php
        $select_options = array('Flags' => 'flags', 'Dropdown' => 'dropdown');
        ?>
        <select name="switcher_type" id="switcher_type">
          <?php
          foreach ($select_options as $label => $value) {
            $selected = '';
            if ($value === $options['switcher_type']) {
              $selected = 'selected';
            }
          ?>
            <option value="<?php echo $value ?>" <?php echo $selected ?>><?php echo $label ?></option>
          <?php
          }
          ?>
        </select>
      </div>
    </div>
    <br />
    <br />
    <h3>Language Switcher styles</h3>
    <div class="postbox">
      <div class="settingsbox">
        <?php
        $class = '';
        if ($options['switcher_type'] != 'flags') {
          $class = 'hidden';
        }
        ?>
        <div id="flag_styles" class="<?php echo $class; ?>">
          <h4>Flags styles</h4>
          <select id="flag_style" name="flag_style">
            <?php
            $dir = new DirectoryIterator(LSFT_PLUGIN_PATH . "/assets/styles/flags");
            foreach ($dir as $fileinfo) {
              if ($fileinfo->getFilename() != '.' && $fileinfo->getFilename() != '..') {
                $file_parts = explode('.', $fileinfo->getFilename());
                $style_name_array = explode('-', $file_parts[0]);
                $selected = '';
                if ($fileinfo->getFilename() == esc_html($options['flag_style'])) {
                  $selected = 'selected';
                  $flags_selected_file = $fileinfo->getPathName();
                }
            ?>
                <option value="<?php echo $fileinfo->getFilename() ?>" <?php echo $selected ?>>
                  <?php echo ucfirst(implode(' ', $style_name_array)); ?>
                </option>
            <?php
              }
            }
            ?>
          </select>
        </div>
        <br>
        <br>
        <?php
        $class = '';
        if ($options['switcher_type'] != 'dropdown') {
          $class = 'hidden';
        }
        ?>
        <div id="dropdown_styles" class="<?php echo $class; ?>">
          <input type="checkbox" id="select_as_list" name="select_as_list" <?php echo $options['select_as_list'] == 'yes' ? 'checked' : '';  ?> /><label>Check if you want to use a an unordered list as dropdown instead of a select.</label>
          <br>
          <div id="select-styles" class="<?php echo $options['select_as_list'] == 'yes' ? 'hidden' : ''; ?>">
            <h4>Select styles</h4>
            <select id="select_style" name="select_style">
              <?php
              // $dir = new DirectoryIterator(LSFT_PLUGIN_PATH . "/assets/styles/select");
              $dir = new DirectoryIterator(plugin_dir_path(dirname(__FILE__, 2)) . "/assets/styles/select");//suggested by
              foreach ($dir as $fileinfo) {
                if ($fileinfo->getFilename() != '.' && $fileinfo->getFilename() != '..') {
                  $file_parts = explode('.', $fileinfo->getFilename());
                  $style_name_array = explode('-', $file_parts[0]);
                  $selected = '';
                  if ($fileinfo->getFilename() == esc_html($options['select_style'])) {
                    $selected = 'selected';
                    $select_selected_file = $fileinfo->getPathName();
                  }
              ?>
                  <option value="<?php echo $fileinfo->getFilename() ?>" <?php echo $selected ?>>
                    <?php echo ucfirst(implode(' ', $style_name_array)); ?>
                  </option>
              <?php
                }
              }
              ?>
            </select>
          </div>
          <br>
          <br>
          <div id="list-styles" class="<?php echo $options['select_as_list'] == 'yes' ? '' : 'hidden'; ?>">
            <h4>List styles</h4>
            <select id="list_style" name="list_style">
              <?php
              $dir = new DirectoryIterator(LSFT_PLUGIN_PATH . "/assets/styles/list");
              foreach ($dir as $fileinfo) {
                if ($fileinfo->getFilename() != '.' && $fileinfo->getFilename() != '..') {
                  $file_parts = explode('.', $fileinfo->getFilename());
                  $style_name_array = explode('-', $file_parts[0]);
                  $selected = '';
                  if ($fileinfo->getFilename() == esc_html($options['select_style'])) {
                    $selected = 'selected';
                    $list_selected_file = $fileinfo->getPathName();
                  }

              ?>
                  <option value="<?php echo $fileinfo->getFilename() ?>" <?php echo $selected ?>>
                    <?php echo ucfirst(implode(' ', $style_name_array)); ?>
                  </option>
              <?php
                }
              }
              ?>
            </select>
            <br>
            <br>
            <h4>List items (flags, text or flags and text)</h4>
            <select name="custom_list_items">
              <?php
              $list_items_options = array('Flag only' => 'flag-only', 'Text only' => 'text-only', 'Flag and text' => 'flag-and-text');
              foreach ($list_items_options as $key => $item) {
                $selected = '';
                if ($item === $options['custom_list_items']) {
                  $selected = 'selected';
                }
              ?>
                <option value="<?php echo esc_html($item); ?>" <?php echo $selected ?>><?php echo esc_html($key) ?></option>
              <?php
              }
              ?>
            </select>
            <br>
          </div>
        </div>
        <br>
        <?php
        $class = '';
        if ($options['select_as_list'] == 'no' && $options['select_style'] == 'default.css') {
          $class = 'disabled';
        }
        if ($options['switcher_type'] == 'flags') {
          $selected_file = $flags_selected_file;
        } else {
          $selected_file = $options['select_as_list'] == 'no' ? $select_selected_file : $list_selected_file;
        }
        ?>
        <div id="custom_css_editor">
          <h3>Language Switcher style editor</h3>
          <br>
          <button id="create_css_file" name="create_css_file" class="button-primary">Create new file</button>
          <br>
          <br>
          <div id="filename-wrapper" class="hidden">
            <label for="filename"></label><input type="text" name="filename" id="filename" />
            <button id="cancel_create_css_file" name="cancel_create_css_file" class="button-cancel">Cancel</button>
          </div>
          <br>
          <br>
          <textarea id="code_editor_page_css" rows="5" name="custom_style" class="widefat textarea <?php echo $class ?>">
          <?php
          echo file_exists($selected_file) ? trim(file_get_contents($selected_file)) : '';
          ?>
          </textarea>
        </div>

      </div>
    </div>
    <br />
    <br />
    <h3>Menu item classes</h3>
    <div class="postbox">
      <div class="settingsbox">
        <p>If your theme uses some specific class for navigation menu items, add them here. Be sure to separate the classes only by a comma. LFST will add these classes to the menu items for the language switcher in order they look and feel accordingly to your theme.</p>
        <input type="text" name="menu_classes" placeholder="class1,class2,class3..." value="<?php echo $options['menu_classes']; ?>" />
      </div>
    </div>
    <br />
    <br />

    <br />
    <br />
    <input type="submit" value="Save changes" class="button-primary" />
  </form>
</div>
